Bug # 40005 (Resolved): Several unit tests fail under Windows system
Subject: Failing unit tests on windows because of symlinks
Description

When running the TYPO3 CMS unit tests on Windows errors ocurr, if the windows configuration is not set accordingly:

1) TYPO3\CMS\Extensionmanager\Tests\Unit\Utility\FileHandlingUtilityTest::removeDirectoryRemovesSymlink
symlink(): Cannot create symlink, error code(1314)

D:\typo3\master\typo3\sysext\extensionmanager\Tests\Unit\Utility\FileHandlingUtilityTest.php:172
D:\typo3\master\Packages\Libraries\phpunit\phpunit\phpunit:62

2)
TYPO3\CMS\Extensionmanager\Tests\Unit\Utility\FileHandlingUtilityTest::removeDirectoryDoesNotRemoveContentOfSymlinkedTargetDirectory
symlink(): Cannot create symlink, error code(1314)

D:\typo3\master\typo3\sysext\extensionmanager\Tests\Unit\Utility\FileHandlingUtilityTest.php:193
D:\typo3\master\Packages\Libraries\phpunit\phpunit\phpunit:62

dTargetDirectory
symlink(): Cannot create symlink, error code(1314)

D:\typo3\master\typo3\sysext\extensionmanager\Tests\Unit\Utility\FileHandlingUtilityTest.php:193
D:\typo3\master\Packages\Libraries\phpunit\phpunit\phpunit:62

According to http://wiki.typo3.org/Flow_Installation_Hints special rights have to be set on Windows in order to be able to create
symlinks.

If TYPO3 is running on Windows, the install tool should try to create a symlink and display a warning if it fails and hint to the according
configuration help.

Related issues:
related to TYPO3.Flow - Bug # 35935: Symlinks still don't work reliably under... Closed 2012-04-13

Associated revisions
Revision 386cd87d - 2015-01-29 18:16 - Nicole Cordes

[BUGFIX] Improve file handling on Windows systems

Calling unlink() on a symlink that points to a directory
fails on Windows. Solution is to use rmdir() instead to
remove the symlink.
Furthermore it fixes a wrong usage of DIRECTORY_SEPARATOR
within the FileHandlingUtility.
Revision c9e8f1d4 - 2015-01-29 18:19 - Nicole Cordes

[BUGFIX] Improve file handling on Windows systems

Calling unlink() on a symlink that points to a directory
fails on Windows. Solution is to use rmdir() instead to
remove the symlink.
Furthermore it fixes a wrong usage of DIRECTORY_SEPARATOR
within the FileHandlingUtility.

Releases: master, 6.2
Resolves: #64409
Change-Id: Idc6ff3eb1214ed8f5cb0f69f15a2d5a6a3dcfafe
Reviewed-on: http://review.typo3.org/36372
Reviewed-by: Christian Kuhn <lolli@schwarzbu.ch>
Tested-by: Christian Kuhn <lolli@schwarzbu.ch>

History
#1 - 2015-01-21 18:25 - Stephan Großberndt

On Windows 7 Home Premium secpol.msc is not available, but "Polsedit - User Policies Editor" from http://www.southsoftware.com/ seems to do the
job to change "SeCreateSymbolicLinkPrivilege".

#2 - 2015-01-23 10:33 - Mathias Schreiber
- Status changed from New to Needs Feedback

Running a website with admin privileges somewhat does not sound like an awesome idea to me :)

#3 - 2015-01-29 15:20 - Nicole Cordes
- Assigned To set to Nicole Cordes
- Parent task set to #40005

#4 - 2015-01-29 15:27 - Gerrit Code Review
- Status changed from Needs Feedback to Under Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/36359

#5 - 2015-01-29 17:12 - Gerrit Code Review

Patch set 2 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/36359

#6 - 2015-01-29 18:17 - Gerrit Code Review

Patch set 1 for branch TYPO3_6-2 of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/36372

#7 - 2015-01-29 18:30 - Nicole Cordes
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:386cd87d37bc24dff5a48468d401571e5e6e8cb6.

#8 - 2015-01-29 20:33 - Nicole Cordes
- Sprint Focus set to On Location Sprint
